﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace netProxy
{
    public partial class Default : System.Web.UI.Page
    {
        private const int BUFFERSIZE = 1048576;

        protected void Page_Load(object sender, EventArgs e)
        {
            HttpWebRequest webRequest = null;
            if (Request.QueryString.Count > 0)
            {
                #region Prepare the request object
                webRequest = (HttpWebRequest)WebRequest.Create(Server.UrlDecode(Request.QueryString.ToString()));
                webRequest.Method = Request.HttpMethod;
                webRequest.ContentType = Request.ContentType;
                #endregion Prepare the request object

                #region Read and Pass POST Data
                if (Request.HttpMethod.ToUpper() == "POST")
                {
                    int postDataLength = (int)Request.InputStream.Length;
                    webRequest.ContentLength = Request.ContentLength;
                    byte[] postData = new byte[postDataLength];

                    Request.InputStream.Read(postData, 0, postDataLength);

                    Stream postStream = webRequest.GetRequestStream();
                    postStream.Write(postData, 0, postDataLength);
                    postStream.Flush();
                }
                #endregion Read and Pass POST Data

                #region Cycle through and return output
                HttpWebResponse webResponse = (HttpWebResponse)webRequest.GetResponse();
                System.IO.Stream fileStream = webResponse.GetResponseStream();
                
                Byte[] buffer = new byte[1048576];
                int bytesRead = 1;
                while (bytesRead > 0)
                {
                    bytesRead = fileStream.Read(buffer, 0, BUFFERSIZE);
                    if (bytesRead == BUFFERSIZE)
                        Response.BinaryWrite(buffer);
                    else if (bytesRead > 0)
                    {
                        byte[] endBuffer = new byte[bytesRead];
                        Array.Copy(buffer, endBuffer, bytesRead);
                        Response.BinaryWrite(endBuffer);
                    }
                }

                fileStream.Dispose();
                webResponse.Close();
                #endregion Cycle through and return output
            }
            else
            {
                #region Return a blank response for malformed queries
                Response.Write("");
                return;
                #endregion Return a blank response for malformed queries
            }
        }
    }
}